
//+------------------------------------------------------------------+
//|                                          KG GGH Signal V.9.0.mq4 |
//|                                       Copyright  2007, Kang_Gun |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property copyright "Copyright  2007, Kang_Gun"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DarkViolet
#property indicator_color2 Yellow
#property indicator_width1  1
#property indicator_width2  1

//extern bool Alert_ON=False;
//extern bool EmailON=false;
//---- input parameters
double MA = 3;
int MA_Mode = 3;
int Price_Type = 6;
double Distance = 0.4;
extern int Arrow_1 = 159;
extern int Arrow_2 = 159;
double CrossUp[];
double CrossDown[];
int flagval1 = 0;
int flagval2 = 0;
extern bool Alert_ON=False;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexArrow(0, Arrow_1);
   SetIndexBuffer(0, CrossUp);
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   SetIndexArrow(1, Arrow_2);
   SetIndexBuffer(1, CrossDown);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 

//----
   return(0);
  }


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int limit, i, counter;
   double tmp=0;
   double fastMAnow, slowMAnow, fastMAprevious, slowMAprevious;
   double Range, AvgRange;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;
   
   for(i = 1; i <= limit; i++) {
   
      counter=i;
      Range=0;
      AvgRange=0;
      for (counter=i ;counter<=i+9;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;
       
      fastMAnow = (iMA(NULL,0,MA,-1,MA_Mode,PRICE_TYPICAL,i)+iMA(NULL,0,MA,-1,MA_Mode,PRICE_OPEN,i))/2;
      fastMAprevious = (iMA(NULL,0,MA,-1,MA_Mode,PRICE_TYPICAL,i+1)+iMA(NULL,0,MA,-1,MA_Mode,PRICE_OPEN,i+1))/2;

      slowMAnow = (iMA(NULL,0,MA,0,MA_Mode,PRICE_TYPICAL,i)+iMA(NULL,0,MA,0,MA_Mode,PRICE_OPEN,i))/2;
      slowMAprevious = (iMA(NULL,0,MA,0,MA_Mode,PRICE_TYPICAL,i+1)+iMA(NULL,0,MA,0,MA_Mode,PRICE_OPEN,i+1))/2;
      
      CrossUp[i] = 0;
      CrossDown[i] = 0;
      if ((fastMAnow >= slowMAnow) && (fastMAprevious < slowMAprevious))
      {
         if (i == 1 && flagval1==0)
         {
           flagval1=1;
           flagval2=0;
           if (Alert_ON) Alert("BUY signal at Ask=",Ask,"\n Bid=",Bid,"\n Time=",TimeToStr(CurTime(),TIME_DATE)," ",TimeHour(CurTime()),":",TimeMinute(CurTime()),"\n Symbol=",Symbol()," Period=",Period());
           //if (EmailON) SendMail("BUY signal alert","BUY signal at Ask="+DoubleToStr(Ask,4)+", Bid="+DoubleToStr(Bid,4)+", Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
         }
         CrossUp[i] = Low[i] - Range*Distance;
      }
      else if ((fastMAnow <= slowMAnow) && (fastMAprevious > slowMAprevious))
      {
         if (i == 1 && flagval2==0)
         {
          flagval2=1;
          flagval1=0;
         if (Alert_ON) Alert("SELL signal at Ask=",Ask,"\n Bid=",Bid,"\n Date=",TimeToStr(CurTime(),TIME_DATE)," ",TimeHour(CurTime()),":",TimeMinute(CurTime()),"\n Symbol=",Symbol()," Period=",Period());
         //if (EmailON) SendMail("SELL signal alert","SELL signal at Ask="+DoubleToStr(Ask,4)+", Bid="+DoubleToStr(Bid,4)+", Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
         }
         CrossDown[i] = High[i] + Range*Distance;
      }
   }

   return(0);
}

